Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jasig.portal
Interface IChannelRegistryStore

All Known Implementing Classes:
  RDBMChannelRegistryStore

    public interface IChannelRegistryStore

Interface defining how the portal reads and writes its channel types, definitions, and categories.

Version:
  $Revision: 1.37 $
Author:
  Ken Weiner, kweiner@unicon.net

Method Summary
`void` | `addCategoryToCategory(ChannelCategory source, ChannelCategory destination)` Makes one category a child of another.
`void` | `addChannelToCategory(ChannelDefinition channelDef, ChannelCategory category)` Associates a channel definition with a category.
`void` | `approveChannelDefinition(ChannelDefinition channelDef, IPerson approver, java.util.Date approveDate)` Sets a channel definition as "approved".
`void` | `deleteChannelCategory(ChannelCategory category)` Deletes a channel category.
`void` | `deleteChannelDefinition(ChannelDefinition channelDef)` Permanently deletes a channel definition from the store.
`void` | `deleteChannelType(ChannelType chanType)` Deletes a channel type.
`void` | `disapproveChannelDefinition(ChannelDefinition channelDef)` Sets a channel definition as "unapproved".
`ChannelCategory` | `getChannelCategory(java.lang.String channelCategoryId)` Gets an existing channel category.
`ChannelDefinition` | `getChannelDefinition(int channelPublishId)` Get a channel definition.
`ChannelDefinition` | `getChannelDefinition(java.lang.String channelFunctionalName)` Get a channel definition.
`ChannelDefinition[]` | `getChannelDefinitions()` Get all channel definitions including ones that haven't been approved.
`ChannelType` | `getChannelType(int channelTypeId)` Get the channel type associated with a particular identifier.
`ChannelType[]` | `getChannelTypes()` Returns an array of ChannelTypes.
`ChannelCategory[]` | `getChildCategories(ChannelCategory parent)` Gets all child channel categories for a parent category.
`ChannelDefinition[]` | `getChildChannels(ChannelCategory parent)` Gets all child channel definitions for a parent category.
`ChannelCategory[]` | `getParentCategories(ChannelCategory child)` Gets the immediate parent categories of this category.
`ChannelCategory[]` | `getParentCategories(ChannelDefinition child)` Gets the immediate parent categories of this channel definition.
`ChannelCategory` | `getTopLevelChannelCategory()` Gets top level channel category
`ChannelCategory` | `newChannelCategory()` Creates a new channel category.
`ChannelCategory` | `newChannelCategory(java.lang.String name, java.lang.String description, java.lang.String creatorId)` Creates a new channel category with the specified values.
`ChannelDefinition` | `newChannelDefinition()` Create a new ChannelDefinition object.
`ChannelType` | `newChannelType()` Creates a new channel type.
`void` | `removeCategoryFromCategory(ChannelCategory child, ChannelCategory parent)` Makes one category a child of another.
`void` | `removeChannelFromCategory(ChannelDefinition channelDef, ChannelCategory category)` Disassociates a channel definition from a category.
`void` | `saveChannelCategory(ChannelCategory category)` Persists a channel category.
`void` | `saveChannelDefinition(ChannelDefinition channelDef)` Persists a channel definition.
`void` | `saveChannelType(ChannelType chanType)` Persists a channel type.

Method Detail

### newChannelType

    ChannelType newChannelType()
                               throws java.lang.Exception

  Creates a new channel type.

  Returns:
    the new channel type
  Throws:
    `java.lang.Exception`

### getChannelType

    ChannelType getChannelType(int channelTypeId)
                               throws java.lang.Exception

  Get the channel type associated with a particular identifier.

  Parameters:
    `channelTypeId` - the channel type identifier
  Returns:
    channelType the channel type
  Throws:
    `java.lang.Exception`

### getChannelTypes

    ChannelType[] getChannelTypes()
                                  throws java.lang.Exception

  Returns an array of ChannelTypes.

  Returns:
    the list of publishable channel types
  Throws:
    `java.lang.Exception`

### saveChannelType

    void saveChannelType(ChannelType chanType)
                         throws java.lang.Exception

  Persists a channel type.

  Parameters:
    `chanType` - a channel type
  Throws:
    `java.lang.Exception`

### deleteChannelType

    void deleteChannelType(ChannelType chanType)
                           throws java.lang.Exception

  Deletes a channel type. The deletion will only succeed if no existing channels reference the channel type.

  Parameters:
    `chanType` - a channel type
  Throws:
    `java.lang.Exception`

### newChannelDefinition

    ChannelDefinition newChannelDefinition()
                                           throws java.lang.Exception

  Create a new ChannelDefinition object.

  Returns:
    the new channel definition
  Throws:
    `java.lang.Exception`

### getChannelDefinition

    ChannelDefinition getChannelDefinition(int channelPublishId)
                                           throws java.lang.Exception

  Get a channel definition.

  Parameters:
    `channelPublishId` - a channel publish ID
  Returns:
    a definition of the channel or `null` if no matching channel definition can be found
  Throws:
    `java.lang.Exception`

### getChannelDefinition

    ChannelDefinition getChannelDefinition(java.lang.String channelFunctionalName)
                                           throws java.lang.Exception

  Get a channel definition. If there is more than one channel definition with the given functional name, then the first one will be returned.

  Parameters:
    `channelFunctionalName` - a channel functional name
  Returns:
    a definition of the channel or `null` if no matching channel definition can be found
  Throws:
    `java.lang.Exception`

### getChannelDefinitions

    ChannelDefinition[] getChannelDefinitions()
                                              throws java.lang.Exception

  Get all channel definitions including ones that haven't been approved.

  Returns:
    channelDefs, the channel definitions
  Throws:
    `java.lang.Exception`

### saveChannelDefinition

    void saveChannelDefinition(ChannelDefinition channelDef)
                               throws java.lang.Exception

  Persists a channel definition.

  Parameters:
    `channelDef` - the channel definition
  Throws:
    `java.lang.Exception`

### deleteChannelDefinition

    void deleteChannelDefinition(ChannelDefinition channelDef)
                                 throws java.lang.Exception

  Permanently deletes a channel definition from the store.

  Parameters:
    `channelDef` - the channel definition
  Throws:
    `java.lang.Exception`

### approveChannelDefinition

    void approveChannelDefinition(ChannelDefinition channelDef,
                                  IPerson approver,
                                  java.util.Date approveDate)
                                  throws java.lang.Exception

  Sets a channel definition as "approved". This effectively makes a channel definition available in the channel registry, making the channel available for subscription.

  Parameters:
    `channelDef` - the channel definition
    `approver` - the user that approves this channel definition
    `approveDate` - the date when the channel definition should be approved (can be future dated)
  Throws:
    `java.lang.Exception`

### disapproveChannelDefinition

    void disapproveChannelDefinition(ChannelDefinition channelDef)
                                     throws java.lang.Exception

  Sets a channel definition as "unapproved". This effectively removes a channel definition from the channel registry, making the channel unavailable for subscription.

  Parameters:
    `channelDef` - the channel definition
  Throws:
    `java.lang.Exception`

### newChannelCategory

    ChannelCategory newChannelCategory()
                                       throws java.lang.Exception

  Creates a new channel category.

  Returns:
    the new channel category
  Throws:
    `java.lang.Exception`

### newChannelCategory

    ChannelCategory newChannelCategory(java.lang.String name,
                                       java.lang.String description,
                                       java.lang.String creatorId)
                                       throws java.lang.Exception

  Creates a new channel category with the specified values.

  Parameters:
    `name` - the name of the category
    `description` - the name of the description
    `creatorId` - the id of the creator or system
  Returns:
    channelCategory the new channel category
  Throws:
    `java.lang.Exception`

### getChannelCategory

    ChannelCategory getChannelCategory(java.lang.String channelCategoryId)
                                       throws java.lang.Exception

  Gets an existing channel category.

  Parameters:
    `channelCategoryId` - the id of the category to get
  Returns:
    the channel category
  Throws:
    `java.lang.Exception`

### getTopLevelChannelCategory

    ChannelCategory getTopLevelChannelCategory()
                                               throws java.lang.Exception

  Gets top level channel category

  Returns:
    the new channel category
  Throws:
    `java.lang.Exception`

### getChildCategories

    ChannelCategory[] getChildCategories(ChannelCategory parent)
                                         throws java.lang.Exception

  Gets all child channel categories for a parent category.

  Returns:
    channelCategories the children categories
  Throws:
    `java.lang.Exception`

### getChildChannels

    ChannelDefinition[] getChildChannels(ChannelCategory parent)
                                         throws java.lang.Exception

  Gets all child channel definitions for a parent category.

  Returns:
    channelDefinitions the children channel definitions
  Throws:
    `java.lang.Exception`

### getParentCategories

    ChannelCategory[] getParentCategories(ChannelCategory child)
                                          throws java.lang.Exception

  Gets the immediate parent categories of this category.

  Returns:
    parents, the parent categories.
  Throws:
    `java.lang.Exception`

### getParentCategories

    ChannelCategory[] getParentCategories(ChannelDefinition child)
                                          throws java.lang.Exception

  Gets the immediate parent categories of this channel definition.

  Returns:
    the parent categories.
  Throws:
    `java.lang.Exception`

### saveChannelCategory

    void saveChannelCategory(ChannelCategory category)
                             throws java.lang.Exception

  Persists a channel category.

  Parameters:
    `category` - the channel category to persist
  Throws:
    `java.lang.Exception`

### deleteChannelCategory

    void deleteChannelCategory(ChannelCategory category)
                               throws java.lang.Exception

  Deletes a channel category.

  Parameters:
    `category` - the channel category to delete
  Throws:
    `java.lang.Exception`

### addCategoryToCategory

    void addCategoryToCategory(ChannelCategory source,
                               ChannelCategory destination)
                               throws java.lang.Exception

  Makes one category a child of another.

  Parameters:
    `source` - the source category
    `destination` - the destination category
  Throws:
    `java.lang.Exception`

### removeCategoryFromCategory

    void removeCategoryFromCategory(ChannelCategory child,
                                    ChannelCategory parent)
                                    throws java.lang.Exception

  Makes one category a child of another.

  Parameters:
    `child` - the category to remove
    `parent` - the category to remove from
  Throws:
    `java.lang.Exception`

### addChannelToCategory

    void addChannelToCategory(ChannelDefinition channelDef,
                              ChannelCategory category)
                              throws java.lang.Exception

  Associates a channel definition with a category.

  Parameters:
    `channelDef` - the channel definition
    `category` - the channel category to which to associate the channel definition
  Throws:
    `java.lang.Exception`

### removeChannelFromCategory

    void removeChannelFromCategory(ChannelDefinition channelDef,
                                   ChannelCategory category)
                                   throws java.lang.Exception

  Disassociates a channel definition from a category.

  Parameters:
    `channelDef` - the channel definition
    `category` - the channel category from which to disassociate the channel definition
  Throws:
    `java.lang.Exception`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD